"
 COPYRIGHT (c) 2008 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libbasic3' }"

"{ NameSpace: Smalltalk }"

Object subclass:#VersionInfo
	instanceVariableNames:'revision binaryRevision user timestamp date time fileName state'
	classVariableNames:''
	poolDictionaries:''
	category:'System-SourceCodeManagement'
!

!VersionInfo class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2008 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    In ancient times, Class used to return a Dictionary when asked for versionInfo.
    This has been replaced by instances of this class and subclasses.

    Notice, that subclasses may add more info for specific source repositories
    (CVSVersionInfo, MonticelloVersionInfo etc.).
    However, any generic tools/ui should only depend on the values (and getters) found here.

    [author:]
        cg (cg@AQUA-DUO)
"
! !

!VersionInfo methodsFor:'accessing'!

at:aKey
    "backward compatible dictionary-like accessing"

    (self respondsTo:aKey) ifTrue:[
        ^ self perform:aKey
    ].
    ^ self errorKeyNotFound:aKey

    "
     self new at:#binaryRevision
     self new at:#foo
    "

    "Modified: / 22-10-2008 / 20:23:31 / cg"
!

at:aKey ifAbsent:replacement
    "backward compatible dictionary-like accessing"

    (self respondsTo:aKey) ifTrue:[
        ^ (self perform:aKey) ? replacement
    ].
    ^ replacement

    "
     self new at:#binaryRevision
     self new at:#foo ifAbsent:#bar
    "

    "Created: / 22-10-2008 / 20:19:42 / cg"
!

at:aKey put:value
    "backward compatible dictionary-like accessing"

    (self respondsTo:aKey) ifTrue:[
        self perform:aKey asMutator with:value.
        ^ value "/ sigh
    ].
    ^ self errorKeyNotFound:aKey

    "
     self new at:#binaryRevision put:#bar
     self new at:#foo put:#bar
    "

    "Created: / 22-10-2008 / 20:20:54 / cg"
!

author
    ^ self user

    "Created: / 21-12-2011 / 23:09:54 / cg"
!

binaryRevision
    ^ binaryRevision
!

binaryRevision:something
    binaryRevision := something.
!

date
    timestamp notNil ifTrue:[^ timestamp asDate].
    ^ date
!

date:something
    date := something.
!

day
    ^ date
!

fileName
    ^ fileName
!

fileName:something
    fileName := something.
!

keysAndValuesDo:aBlock
    self class instVarNames do:[:nm |
        aBlock value:(nm asSymbol) value:(self perform:nm asSymbol)
    ].

    "Created: / 22-10-2008 / 20:48:08 / cg"
!

majorVersion
    |v|

    v := self revision.
    v notEmptyOrNil ifTrue:[
        ^ v upTo:$.
    ].
    ^ nil

    "
     Array revisionInfo majorVersion
    "
!

minorVersion
    |v|

    v := self revision.
    v notEmptyOrNil ifTrue:[
        ^ v copyFrom:(v indexOf:$.)+1
    ].
    ^ nil

    "
     Array revisionInfo minorVersion
    "
!

repositoryPathName
    "raise an error: must be redefined in concrete subclass(es)"

    ^ nil "Not known"

    "Modified: / 23-11-2011 / 23:33:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

revision
    ^ revision
!

revision:something
    revision := something.
!

state
    ^ state
!

state:something
    state := something.
!

symbolicVersionName
    "iff that source code manager uses cryptic names for versions,
     (eg. dbManager, git and hg managers), we may add an additional symbolic
     version name, which is used for human readers (and not required to be unique).
     Usually something like x.y-nn, where nn is the user name is returned there.
     Here, we return the revision proper, which is ok for cvs, svn and others with a 
     user-friendly version number."

    ^ revision
!

time
    timestamp notNil ifTrue:[^ timestamp asTime].
    ^ time
!

time:something
    time := something.
!

timeStamp:aTimestamp
    date := aTimestamp asDate.
    time := aTimestamp asTime.

    "Created: / 04-12-2011 / 10:06:02 / cg"
!

timestamp
    timestamp notNil ifTrue:[^ timestamp].
    date isNil ifTrue:[^ nil].
    time isNil ifTrue:[^ date asTimestamp].
    ^ Timestamp fromDate:date andTime:time
!

timestamp:aTimestamp
    timestamp := aTimestamp

    "Created: / 04-12-2011 / 10:06:02 / cg"
!

timezone
    "raise an error: must be redefined in concrete subclass(es)"

    ^ nil "Not known"

    "Modified: / 23-11-2011 / 13:54:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

user
    ^ user
!

user:something
    user := something.
! !

!VersionInfo class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

